module usb_ehci_host_controller(
	input			clock_60,
	// input			clock_480,
	input			reset_n,
	
	output			led1,
	
	output			interrupt_o,
	output			cpu_resetn,
	input	[31:0]	apb_paddr,    
	input			apb_penable,  
	output	[31:0]	apb_prdata,   
	output			apb_pready,   
	input			apb_psel,     
	input	[31:0]	apb_pwdata,   
	input			apb_pwrite,   
	output			apb_pslverror,
	
	// inout	 [7:0]	data,
	// output	 [7:0]	addr,
	// output	 		cs_n,
	// output	 		wr_n,
	// output	 		rd_n,
	// input			dreq,
	// output	 		dack,
	// input			interrupt_i,
	
	output			phy_rst		,	
	input			ulpi_dir_i  ,    
	input			ulpi_nxt_i	,    
	inout [  7:0]	ulpi_data_io,			
	output			ulpi_stp_o,         
	
	output			r_hardware_interrupt		,	
	output			r_phy_clk		,	
	output			r_phy_rst		,	
	output			r_ulpi_dir_i  ,    
	output			r_ulpi_nxt_i	,    
	output [  7:0]	r_ulpi_data_i,		
	output [  7:0]	r_ulpi_data_o,			
	output			r_ulpi_stp_o         
	
	// inout			d_usb_dxp_io		,
    // inout			d_usb_dxn_io		,
	
    // input			d_usb_rxdp_i		,
    // input			d_usb_rxdn_i		,	
	
	// inout			d_usb_dp_pullup_o	,
    // inout			d_usb_dn_pullup_o	,
    // inout			d_usb_term_dp_io	,
    // inout			d_usb_term_dn_io		
);

wire [7:0]		data;
wire [7:0]		data_i;
wire [7:0]		data_o;
wire			data_en;
wire [7:0]		addr;
wire			cs_n;
wire			wr_n;
wire			rd_n;
wire			dreq;
wire			dack;
wire			hardware_interrupt;
wire [7:0]	ulpi_data_out_i ;
wire [7:0]	ulpi_data_in_o ;
reg				led1_t;
reg		[31:0]	cnt1;

assign led1		= led1_t;

// assign r_hardware_interrupt = hardware_interrupt;
// assign r_phy_clk			= phy_clk;	
// assign r_phy_rst			= phy_rst;	
// assign r_ulpi_dir_i			= ulpi_dir_i;    
// assign r_ulpi_nxt_i			= ulpi_nxt_i;    
// assign r_ulpi_data_i		= ulpi_data_out_i;		
// assign r_ulpi_data_o		= ulpi_data_in_o;			
// assign r_ulpi_stp_o			= ulpi_stp_o;

always@(posedge clock_60 or negedge reset_n) begin
	if(!reset_n) begin
		cnt1		<= 32'd0;
		led1_t		<= 1'b0;
	end
	else begin
		if(cnt1 < 32'd60000000) begin
			cnt1		<= cnt1 + 1'd1;
			led1_t		<= led1_t;
		end
		else begin
			cnt1		<= 32'd0;
			led1_t		<= !led1_t;
		end
	end
end


apb3_to_sram apb3_to_sram_inst(
	.clk				(clock_60), // input				
	.rst_n				(reset_n), // input				
	.data				(data), // inout	[7:0]		
	.addr				(addr), // output	reg [7:0]	
	.cs_n				(cs_n), // output	reg 		
	.wr_n				(wr_n), // output	reg 		
	.rd_n				(rd_n), // output	reg 		
	.dreq				(dreq), // input				
	.dack				(dack), // output	reg 		
	.interrupt_i		(hardware_interrupt), // input				
	.interrupt_o		(interrupt_o), // output				
	.cpu_resetn			(cpu_resetn),
	.apb_paddr			(apb_paddr		), // input	[31:0]		    
	.apb_penable		(apb_penable	), // input				  
	.apb_prdata			(apb_prdata		), // output	reg [31:0]	   
	.apb_pready			(apb_pready		), // output	reg 		   
	.apb_psel			(apb_psel		), // input				     
	.apb_pwdata			(apb_pwdata		), // input	[31:0]		   
	.apb_pwrite			(apb_pwrite		), // input				   
	.apb_pslverror		(apb_pslverror	)  // output	reg 		
	
);

assign ulpi_data_out_i = ulpi_data_io ;
assign ulpi_data_io = ( ulpi_dir_i ) ? 8'bz : ulpi_data_in_o ;

// USB_Host_Controller_Top USB_Host_Controller_Top_inst
// (
	 // .clk 						(clock_60 				   	)
	// ,.rst_n                     (reset_n                 	)
	
	// ,.cs_n_i                    (cs_n                	)
	// ,.rd_n_i                    (rd_n                	)
	// ,.wr_n_i                    (wr_n                	)
	// ,.addr_i                    (addr                	)
	// ,.dat_io                    (data               	)
	
	// ,.dreq_o                    (dreq                	)
	// ,.dack_i                    (dack               	)
	
	// ,.hardware_interrupt_o      (hardware_interrupt  	)

	// ,.phy_rst_o                 (phy_rst            	)
	// ,.ulpi_dir_i                (ulpi_dir_i            	)
	// ,.ulpi_nxt_i	            (ulpi_nxt_i	        	)
	// ,.ulpi_data_out_i			(ulpi_data_out_i		)
	// ,.ulpi_data_in_o	        (ulpi_data_in_o			)
	// ,.ulpi_stp_o         	    (ulpi_stp_o         	)
// );

assign data_i = data;
assign data = data_en ? data_o : 8'bZ;

// USB_Host_Controller_Top USB_Host_Controller_Top_inst
// (
	 // .clk 						(clock_60 				   	)
	// ,.rst_n                     (reset_n                 	)
	
	// ,.cs_n_i                    (cs_n                	)
	// ,.rd_n_i                    (rd_n                	)
	// ,.wr_n_i                    (wr_n                	)
	// ,.addr_i                    (addr                	)
	// ,.dat_i                     (data_i               	)
	// ,.dat_o                     (data_o             	)
	// ,.dat_o_en                  (data_en               	)
	
	// ,.dreq_o                    (dreq                	)
	// ,.dack_i                    (dack               	)
	
	// ,.hardware_interrupt_o      (hardware_interrupt  	)

	// ,.phy_rst_o                 (phy_rst            	)
	// ,.ulpi_dir_i                (ulpi_dir_i            	)
	// ,.ulpi_nxt_i	            (ulpi_nxt_i	        	)
	// ,.ulpi_data_out_i			(ulpi_data_out_i		)
	// ,.ulpi_data_in_o	        (ulpi_data_in_o			)
	// ,.ulpi_stp_o         	    (ulpi_stp_o         	)
// );

USB20_Host_Controller_Top USB_Host_Controller_Top_inst(
		.clk_i(clock_60), //input clk_i
		.rst_n_i(reset_n), //input rst_n_i
		.cs_n_i(cs_n), //input cs_n_i
		.rd_n_i(rd_n), //input rd_n_i
		.wr_n_i(wr_n), //input wr_n_i
		.addr_i(addr), //input [7:0] addr_i
		.dat_i(data_i), //input [7:0] dat_i
		.dat_o(data_o), //output [7:0] dat_o
		.dat_o_en(data_en), //output dat_o_en
		.dreq_o(dreq), //output dreq_o
		.dack_i(dack), //input dack_i
		.hardware_interrupt_o(hardware_interrupt), //output hardware_interrupt_o
		.phy_rst_o(phy_rst), //output phy_rst_o
		.ulpi_dir_i(ulpi_dir_i), //input ulpi_dir_i
		.ulpi_nxt_i(ulpi_nxt_i), //input ulpi_nxt_i
		.ulpi_data_out_i(ulpi_data_out_i), //input [7:0] ulpi_data_out_i
		.ulpi_data_in_o(ulpi_data_in_o), //output [7:0] ulpi_data_in_o
		.ulpi_stp_o(ulpi_stp_o) //output ulpi_stp_o
	);


endmodule